ArrayList<Cat> cats = new ArrayList<Cat>();
int num_of_cats = 6;

int num_of_cat_img = 50;

class Cat{
  float size_factor = 0.9/num_of_cats;
  float x, y;
  float flow_speed = -0.1*width;
  float flow_t = 0; // 0~1;
  float h_offset = -0.015*height;
  PImage img;
  
  float oscillation_period = 1;
  float oscillation_r = 0.002*height;
  float oscillation_t = 0;
  
  int last_frame_millis;
  
  Cat(float _x)
  {
    x = _x;
    int cat_img_index = floor(random(1,num_of_cat_img+0.999));
    img = loadImage("pusheen/"+cat_img_index+".png");
  }
  
  void Draw()
  {
    Move();
    DrawCat();
  }
  
  void Move()
  {
    float y_floor = (1 - size_factor/2)*height;
    float y_water = height*(1- waterLine.h *  waterLine.h_max_height) * 0.98  + h_offset;
    if(y_floor < y_water){
      y = y_floor;
    }else{
      oscillation_t += (float)(millis() - last_frame_millis) / 1000;
      float osc_del_h = oscillation_r * sin(oscillation_t/oscillation_period * TWO_PI);
      y = y_water + osc_del_h;
      
      last_frame_millis = millis();
      
      
      //flow
      if(waterLine.h > 0.99){
        flow_t = min(1, flow_t + timer.deltaTime());
        x += flow_speed * flow_t * timer.deltaTime();
        oscillation_r = 0.004*height;
      }
    }
  }
  void DrawCat()
  {
    pushMatrix();
    translate(x,y);
    scale(-1,1);
    translate(-x,-y);
    imageMode(CENTER);
    image(img,x,y,size_factor*width,size_factor*height);
    imageMode(CORNERS);    
    popMatrix();
  }
}